##\8.2 ̌vZXNvg
path<- "http://mjin.doshisha.ac.jp/data/JYO113y.csv"
akuta<-read.csv(path,row.names=1)
library(glmnet)
library(pls)
m=4
k=10
nr<-nrow(akuta)
nc<-ncol(akuta)
resu<-matrix(0,nr,m)
set.seed(1)
ncv<-pls::cvsegments(nr,k=k) #10 tH[h̕s
for(i in 1:k){ #mFs
  cnum<-ncv[[i]]
  X<- as.matrix(akuta[-cnum,-nc])
  Y<- as.matrix(akuta[-cnum,nc])
  Xtest<-as.matrix(akuta[cnum,-nc])
  ####dALm
  LM<-step(lm(y~.,akuta[-cnum,]),trace=FALSE)
  resu[cnum,1]<-predict(LM,akuta[cnum,-nc])
  ####Ridge A& minimal_CV
  fit<- glmnet(x=X,y=Y,family="gaussian",alpha=0)
  resu[cnum,2]<- predict(fit,newx=Xtest,s=min(fit$lambda))[,1]
  ####Elastic net & minimal_CV
  fit<- glmnet(x=X,y=Y,family="gaussian",alpha=0.5)
  resu[cnum,3]<- predict(fit,newx=Xtest,s=min(fit$lambda))[,1]
  ####Lasso & minimal_CV
  fit<- glmnet(x=X,y=Y,family="gaussian",alpha=1)
  resu[cnum,4]<- predict(fit,newx=Xtest,s=min(fit$lambda))[,1]
}
sqres<-(resu-akuta$y)^2 @@@@#c̓߂
me<-apply(sqres,2,mean)
sd<-apply(sqres,2,sd)/sqrt(nr)
kekka<-round(rbind(mean=me,sd=sd),3)
colnames(kekka)<-c("Lm","Ridge","Elastic net","Lasso")
kekka

####}8.4
X<-as.matrix(akuta[,-41]); Y<-akuta$y
cv1<- cv.glmnet(x=X,y=Y,family="gaussian",alpha=0)
cof1<-coef(cv1,s='lambda.1se')[-1,]
cof2<-sort(abs(cof1))
windows()
dotchart(tail(cof2,n=20))
grid()
####}8.5
cv1<- cv.glmnet(x=X,y=Y,family="gaussian",alpha=1)
cof1<-coef(cv1,s='lambda.1se')[-1,]
cof2<-sort(abs(cof1))
windows()
dotchart(cof2[cof2>0])
grid()
####}8.6
cv1<- cv.glmnet(x=X,y=Y,family="gaussian",alpha=0.5)
cof1<-coef(cv1,s='lambda.1se')[-1,]
cof2<-sort(abs(cof1))
windows()
dotchart(cof2[cof2>0])
grid()
